import sys
import re


class statement:
    def __init__(self, num):
        self.location = ''
        self.result = []
        self.operand = []
        self.comments = ''
        self.valid_instr = 0

class instruction:
    def __init__(self, num):
        self.code = ""          #16 bits
        self.instruction = ""
        self.defined_location = 1
        self.data = 0

def expr_eval(expression):
    #first split the expression into individual tokens to parse
    #tokens = re.compile('(\+|\-|\*|\/)')    #putting the regex in ()'s includes the tokens for some reason
    #tokens = tokens.split(expression)
    #if "" in tokens:
    #    tokens.remove("")
    tokens = expression
    result = 0
    temp_int = 0
    i=0
    mode = "+"
    pound_mode = False
    #now let's evaluate the expression
    while(i<len(tokens)):
        #First, check if it's a number or an operator
        if tokens[i] not in ['+','-','*','/','#']:
            #It's a number! Now, let's convert it into an integer
            if tokens[i] in a_type or tokens[i] in s_type or tokens[i] in v_type:
                print "Error! Trying to evaluate regs as expression"
                print "tokens:"
                print tokens
                #sys.exit()
            elif tokens[i] in symbols:                            #it's an already-defined symbol!
                temp_int=symbols[tokens[i]]
            elif tokens[i] in locations:
                temp_int=locations[tokens[i]]
            elif tokens[i][0]=="O" and tokens[i][1]=="'":       #it's an octal number
                temp_int=int("0" + tokens[i].lstrip("O'"),8)   #chop off the leading 2 characters and replace with a "0" to make it python-friendly
                #print "explicit octal detected"
            elif tokens[i][0]=="D" and tokens[i][1]=="'":       #it's a decimal number
                temp_int=int(tokens[i].lstrip("D'"))           #chop off the leading 2 characters to make it python friendly
            elif tokens[i][0]=="A" and tokens[i][1]=="'" or tokens[i][0]=="'":  #it's an ASCII string
                temp_int=tokens[i]
            else:                                               #It's an octal number, but with no "O'" prefix
                #if runmode=='debug':
                    #print "implicit octal detected while evaluation expression: "
                    #print  expression
                temp_int=int("0" + tokens[i],8)
                #print "implicit octal detected"
            
            if mode == "+":
                result = result + temp_int
            elif mode == "-":
                result = result - temp_int
            elif mode == "*":
                result = result*temp_int
            elif mode == "/":
                result = result/temp_int
        else:
            if tokens[i]=='#':
                pound_mode=True
            else:
                mode = tokens[i]
        i=i+1
    #if result < 0:
    #    result = result % 0100000000
    return result

def is_s_type(op):
    if op in s_type:
        return True 
    else:
        return False 

def is_fs_type(op):
    if op[0]=='F' and op[1:] in s_type:
        return True
    else:
        return False

def is_hs_type(op):
    if op[0]=='H' and op[1:] in s_type:
        return True
    else:
        return False

def is_rs_type(op):
    if op[0]=='R' and op[1:] in s_type:
        return True
    else:
        return False

def is_is_type(op):
    if op[0]=='I' and op[1:] in s_type:
        return True
    else:
        return False


def is_a_type(op):
    if op in a_type:
        return True
    else:
        return False

def is_fa_type(op):
    if op[0]=='F' and op[1:] in a_type:
        return True
    else:
        return False

def is_v_type(op):
    if op in v_type:
        return True
    else:
        return False

def is_fv_type(op):
    if op[0]=='F' and op[1:] in v_type:
        return True
    else:
        return False

def is_iv_type(op):
    if op[0]=='I' and op[1:] in v_type:
        return True
    else:
        return False

def is_hv_type(op):
    if op[0]=='H' and op[1:] in v_type:
        return True
    else:
        return False

def is_rv_type(op):
    if op[0]=='R' and op[1:] in v_type:
        return True
    else:
        return False

def is_b_type(op):
    if op[0]=='B':
        if op[1]=='.':
            return True
        elif op[1:].isdigit():
            return True
        else:
            return False
    else:
        return False

def is_t_type(op):
    if op[0]=='T':
        if op[1]=='.':
            return True
        elif op[1:].isdigit():
            return True
        else:
            return False
    else:
        return False

def is_reg_type(op):
    if is_s_type(op) or is_a_type(op) or is_v_type(op) or is_b_type(op) or is_t_type(op):
        return True
    else:
        return False

def is_expression(op_list):
    valid_expression = True
    for i in op_list:
        if ((i in expression_operators) or (i.isdigit() or (i[0:2] in ["D'","O'","A'"]) or (i in symbols) or (i in locations)))==False:
            valid_expression = False
    return valid_expression


def is_defined_expression(op_list):
    for i in op_list:
        if i in locations:
            if locations[i]=="":
                return False
    return True

def get_jk_from_bt(op):
    tmp_jk = ''
    if op[1] != ".":     #it's an explicit register
                if len(op)==3:
                    tmp_jk = op[1] + op[2]
                elif len(op)==2:
                    tmp_jk = "0" + op[1]
                else:
                    print "Error! Format must be B# or B##"
    else:                    #it's a symbol for the register value
        tmp_jk = "%02o" % symbols[op[2:]]
    return tmp_jk


runmode = "normal"
input_file = "cal_dv.txt"
if len(sys.argv)>=2:
    input_file = sys.argv[1]
if len(sys.argv)==3:
    runmode = sys.argv[2]
    print "mode:" + runmode

split_file_name = input_file.split(".")
output_file = split_file_name[0] + '.SV'
infile = open(input_file,"r")
raw_assembly = infile.readlines()
infile.close()

formatted_code = []
program_name = ''
program_entry = []
program_origin = 0
symbols = {}
locations = {}
s_type = ["S0","S1","S2","S3","S4","S5","S6","S7","S."]
a_type = ["A0","A1","A2","A3","A4","A5","A6","A7","A."]
v_type = ["V0","V1","V2","V3","V4","V5","V6","V7","V."]
expression_operators = ['#','+','-','*','/']

#First, we want to load in the raw text file and
#parse it into "Location", "Result", "Operand" and "Comments" fields
for line in raw_assembly:
    index = len(formatted_code)
    formatted_code.append(statement(index))
    #First, check if it is a comment-only line
    if line[0]=="*" or (len(line) > 35 and line[0:34]=="                                   "):
        formatted_code[index].result = ['']
        formatted_code[index].operand = ['']
        formatted_code[index].comments = line
    #Otherwise, it's just a normal instruction
    else:
        #check for location field
        if line[0:2]!="  ":
            formatted_code[index].location = line[0:8].strip()
        re_tokens = re.compile('(\\\\|&|\^|<|>|#|\+|,|-|\*|/|!)')    #putting the regex in ()'s includes the tokens for some reason
        formatted_code[index].result  = re_tokens.split(line[9:18].strip())
        while "" in formatted_code[index].result:
            formatted_code[index].result.remove("")
        formatted_code[index].operand = re_tokens.split(line[19:34].strip())
        while "" in formatted_code[index].operand:
            formatted_code[index].operand.remove("")
        formatted_code[index].comments = line[34:].strip()
        print formatted_code[index].comments
        if formatted_code[index].result[0] != "=" and \
            formatted_code[index].result[0]!="IDENT" and \
            formatted_code[index].result[0]!="ENTRY" and \
            formatted_code[index].result[0]!="ABS" and \
            formatted_code[index].result[0]!="END" and \
            formatted_code[index].result[0]!="EJECT" and \
            formatted_code[index].result[0]!="LIST" and \
            formatted_code[index].result[0]!="ORG":         #detect symbols and psuedo-instructions
            formatted_code[index].valid_instr = 1


#We now have all of our code parsed into fields and stored in the "formatted code" array.
#Let's start turning it into instructions!

if runmode=="debug":
    for i in formatted_code:
        print "location: " + i.location
        print "result: " 
        print i.result
        print "operand: "
        print  i.operand
        print "comments: " + i.comments
        print "valid instr: " + str(i.valid_instr)
        print ""

for i in formatted_code:
    if i.result[0]=="=":                        #First, check if it is a real symbol-define statement
        if runmode=="debug":
            print "Symbol found!"
        symbols[i.location]=expr_eval(i.operand)
    elif i.location!="":                        #Then, Check if it's a line with a defined location name
        if runmode=="debug":
            print "Location found!"
        locations[i.location]=""
    elif i.result[0]=="IDENT":
        program_name = i.operand[0]
    elif i.result[0]=="ENTRY":
        program_entry.append(i.operand[0])
    elif i.result[0]=="ORG":
        program_origin = expr_eval(i.operand)

if runmode =="debug":
    print "Symbols:"
    print symbols
    print "Locations:"
    print locations

#Let's go through and start defining instructions
instr_code = []
undecoded_instructions = 0
for i in formatted_code:
    index = len(instr_code)
    tmp_code = ""
    if i.valid_instr==1:
        #BSS / BSSZ Pseudo-instruction (what's the difference? Not sure)
        if len(i.result)==1 and (i.result[0] == "BSS" or i.result[0] == "BSSZ"):
            #First, do a FORCE_UPPER, and round up to the next full-word by inserting "S1 S1&S1" (NOP) statements
            if (index % 4)==3:
                instr_code.append(instruction(index))
                instr_code[index].code = "044111"                     #Insert NOPs (S1 S1&S1)
            elif (index % 4)==2:
                instr_code.append(instruction(index))
                instr_code[index].code = "044111"                     #Insert NOPs (S1 S1&S1)
                instr_code.append(instruction(index+1))
                instr_code[index+1].code = "044111"                   
            elif (index % 4)==1:
                instr_code.append(instruction(index))
                instr_code[index].code = "044111"                     #Insert NOPs (S1 S1&S1)
                instr_code.append(instruction(index+1))
                instr_code[index+1].code = "044111"                   
                instr_code.append(instruction(index+2))
                instr_code[index+2].code = "044111"                   
            index = len(instr_code)                                 #recompute the 'index' value
            if i.location != "":                                    #assign location to start of first full word
                locations[i.location]=index + program_origin
            block_size = expr_eval(i.operand)
            for offset in range(0,block_size*4):
                index = len(instr_code)
                instr_code.append(instruction(index))
                instr_code[index].code = "000000"           #just zero fill data block
                instr_code[index].data = 1

        # CON = Generate a full-word CONstant value
        elif len(i.result)==1 and i.result[0] == "CON" and is_expression(i.operand):
            #First, do a FORCE_UPPER, and round up to the next full-word by inserting "S1 S1&S1" (NOP) statements
            if (index % 4)==3:
                instr_code.append(instruction(index))
                instr_code[index].code = "044111"                     #Insert NOPs (S1 S1&S1)
            elif (index % 4)==2:
                instr_code.append(instruction(index))
                instr_code[index].code = "044111"                     #Insert NOPs (S1 S1&S1)
                instr_code.append(instruction(index+1))
                instr_code[index+1].code = "044111"
            elif (index % 4)==1:
                instr_code.append(instruction(index))
                instr_code[index].code = "044111"                     #Insert NOPs (S1 S1&S1)
                instr_code.append(instruction(index+1))
                instr_code[index+1].code = "044111"
                instr_code.append(instruction(index+2))
                instr_code[index+2].code = "044111"
            index = len(instr_code)                                 #recompute the 'index' value
            if i.location != "":                                    #assign location to start of first full word
                locations[i.location]=index + program_origin
            instr_code.append(instruction(index))
            instr_code.append(instruction(index+1))
            instr_code.append(instruction(index+2))
            instr_code.append(instruction(index+3))
            tmp_val = "%016x" % expr_eval(i.operand)
            #print "CON hex val:" + tmp_val
            instr_code[index].code = "%06o" % int(tmp_val[12:16],16)
            instr_code[index].data = 1
            instr_code[index+1].code = "%06o" % int(tmp_val[8:12],16)
            instr_code[index+1].data = 1
            instr_code[index+2].code = "%06o" % int(tmp_val[4:8],16)
            instr_code[index+2].data = 1
            instr_code[index+3].code = "%06o" % int(tmp_val[0:4],16)
            instr_code[index+3].data = 1


        #000 ERR
        elif len(i.result)==1 and i.result[0] == "ERR":
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            instr_code[index].code = '000000'
        #002 VL     AK      Transmit Ak to VL
        elif len(i.result)==1 and i.result[0] == "VL":
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if is_a_type(i.operand[0])==False:
                print "Error! Can't assign non-A# reg to VL"
                break
            instr_code[index].code = '00200' + i.operand[0][1]

        #003 VM     Sj      Transmit Sj to VM
        elif len(i.result)==1 and i.result[0] == "VM" and len(i.operand)==1 and is_s_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if is_s_type(i.operand[0])==False:
                print "Error! Can't assign non-S# reg to VM"
                break
            instr_code[index].code = '0030' + i.operand[0][1] + '0'

        #004 EX     Oprnd   Normal Exit
        elif i.result[0] == "EX":
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.operand)==0:
                instr_code[index].code = '004000'
            else:
                if is_defined_expression(i.operand):
                    instr_code[index].code = '004' + "%03o" % expr_eval(i.operand)
                else:
                    print "004: Error, expression must be previously defined"
                    sys.exit()
 
        #005 J      Bjk     Branch to (Bjk)
        #This instruction sets the P register to the parcel address specified
        #by the contents of Bjk, and execution continues at that address.
        elif i.result[0] == "J" and is_b_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = "0050" + get_jk_from_bt(i.operand[0])

        #006 J      exp     Branch to ijkm
        #This instruction sets the P register to the parcel address specified
        #by the low order 24 bits of the ijkm field, and execution continues at
        #that address. The high order bit of the ijkm field is ignored.
        elif i.result[0] == "J" and is_b_type(i.operand[0]) == False:
            instr_code.append(instruction(index))               #add the op-code + ijk
            instr_code.append(instruction(index+1))             #add "m"
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            tmp_code = "006"
            if is_defined_expression(i.operand):
                tmp_val = "%06x" % expr_eval(i.operand)     #tmp_val now holds the destination as a 6-digit hex string value
            else:
                tmp_val = "%06x" % 0
                instr_code[index].defined_location = 0
                
            mval    = "%06o" % int(tmp_val[2:6],16)     #figure out the lowest 16 bits of the destination (the "M" value), and convert to 6-digit octal
            instr_code[index+1].code = mval             #write out the 6-digit octal value as the following 16-bit instruction
            tmp_code = tmp_code + "%03o" % int(tmp_val[0:2],16) #now write out the remaining part of the address as the lower 9 bits of the jump-instruction
            instr_code[index].code = tmp_code

        #007 R     exp     Return jump to ijkm
        #This instruction sets register B00 to the address of the following
        #parcel. The P register is then set to the parcel address specified
        #by the low order 24 bits of the ijkm field, and execution continues 
        #at that address. The high order bit of the ijkm field is ignored.
        #The purpose of this instruction is to provie a return linkage for
        #subroutine calls. The subroutine is entered via a return jump. The
        #subroutine returns to the caller at the instruction following the call
        #by executing a branch instruction on the contents of B00 (005)
        elif i.result[0] == "R":
            instr_code.append(instruction(index))               #add the op-code + ijk
            instr_code.append(instruction(index+1))             #add "m"
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            tmp_code = "007"
            if is_defined_expression(i.operand):
                tmp_val = "%06x" % expr_eval(i.operand)     #tmp_val now holds the destination as a 6-digit hex string value
            else:
                tmp_val = "%06x" % 0
                instr_code[index].defined_location = 0
            mval    = "%06o" % int(tmp_val[2:6],16)     #figure out the lowest 16 bits of the destination (the "M" value), and convert to 6-digit octal
            instr_code[index+1].code = mval             #write out the 6-digit octal value as the following 16-bit instruction
            tmp_code = tmp_code + "%03o" % int(tmp_val[0:2],16) #now write out the remaining part of the address as the lower 9 bits of the jump-instruction
            instr_code[index].code = tmp_code

        #010 JAZ    exp         Branch to ijkm if A0=0
        #011 JAN    exp         Branch to ijkm if A0!=0
        #012 JAP    exp         Branch to ijkm if A0 positive
        #013 JAM    exp         Branch to ijkm if A0 negative
        #014 JSZ    exp         Branch to ijkm if S0=0
        #015 JSN    exp         Branch to ijkm if S0!=0
        #016 JSP    exp         Branch to ijkm if S0 positive
        #017 JSM    exp         Branch to ijkm if S0 negative
        #These instructions test the contents of A0 for the condition speci-
        #fied. If the condition is satisfied, the P register is set to the
        #parcel address specified by the low order 24 bits of the ijkm field,
        #and execution continues at that address. The high order bit of the 
        #ijkm field is ignored. If the condition is not satisfied, execution
        #continues with the instruction following the branch instruction. If
        #A0 contains zero, it is considered positive.
        elif i.result[0] in ["JAZ","JAN","JAP","JAM","JSZ","JSN","JSP","JSM"]:
            instr_code.append(instruction(index))               #add the op-code + ijk
            instr_code.append(instruction(index+1))             #add "m"
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if i.result[0]=="JAZ":
                tmp_code = "010"
            elif i.result[0]=="JAN":
                tmp_code = "011"
            elif i.result[0]=="JAP":
                tmp_code = "012"
            elif i.result[0]=="JAM":
                tmp_code = "013"
            elif i.result[0]=="JSZ":
                tmp_code = "014"
            elif i.result[0]=="JSN":
                tmp_code = "015"
            elif i.result[0]=="JSP":
                tmp_code = "016"
            else:       #JSM
                tmp_code = "017"
            if is_defined_expression(i.operand):
                #print i.operand
                tmp_val = "%06x" % expr_eval(i.operand)     #tmp_val now holds the destination as a 6-digit hex string value
            else:
                tmp_val = "%06x" % 0
                instr_code[index].defined_location = 0
            mval    = "%06o" % int(tmp_val[2:6],16)     #figure out the lowest 16 bits of the destination (the "M" value), and convert to 6-digit octal
            instr_code[index+1].code = mval             #write out the 6-digit octal value as the following 16-bit instruction
            tmp_code = tmp_code + "%03o" % int(tmp_val[0:2],16) #now write out the remaining part of the address as the lower 9 bits of the jump-instruction
            instr_code[index].code = tmp_code

        #020 Ai         exp     Transmit jkm to Ai
        #    Ai         #exp    
        #021 Ai         exp     Transmit jkm to Ai and complement
        #021 Ai         #exp
        #This two-parcel instruction enters the 22-bit quantity of the jkm
        #field into Ai. The quantity is treated as a 22-bit positive integer;
        #the upper bits of Ai are cleared. The assembler generates this in-
        #struction when no #symbol precedes the expression and the value of
        #the expression exceeds 63. If all symbols in the expression have not
        #been previously defined, this instruction is generated when the ex-
        #pression value is positive even though the value may be less than
        #64. When the # symbol precedes the expression, the expression is
        #first evaluated and if the value is negative, it is complemented and
        #the complemented value is stored in the jkm field. The complement is 
        #formed by changing all 1 bits to zero and all 0 bits to one. When the
        #expression is positive, an 021 instruction is generated (see below).

        #Just ignoring the ability to generate 022 instructions for now (single parcel immediate load to Ai)
        #FIXME: Updated to properly evaluate '#' symbol
        elif is_a_type(i.result[0]) and is_expression(i.operand)==True:
            instr_code.append(instruction(index))               #add the op-code + ijk
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if is_defined_expression(i.operand):
                if i.operand[0][0]=='#':
                    tmp_val = expr_eval(i.operand[1:])
                else:
                    tmp_val = expr_eval(i.operand)
            else:
                tmp_val = 65   #just so it doesn't generate an 022 instruction
                instr_code[index].defined_location = 0
            if i.operand[0][0]=='#' and tmp_val >= 0 and tmp_val < 2097152:
                instr_code.append(instruction(index+1))             #add "m"
                tmp_val = "%06x" % expr_eval(i.operand)
                instr_code[index].code = '021' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)
            elif i.operand[0][0]=='#' and ((tmp_val < 0) or (tmp_val > 2097152)):
                instr_code.append(instruction(index+1))             #add "m"
                tmp_val = "%06x" % ~expr_eval(i.operand)
                instr_code[index].code = '020' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)
            elif i.operand[0][0]!='#' and tmp_val >= 0 and tmp_val < 2097152:
                if tmp_val < 64 and tmp_val >= 0:
                    tmp_val  = "%06x" % expr_eval(i.operand)
                    instr_code[index].code = '022' + i.result[0][1] + "%02o" % expr_eval(i.operand)
                else:
                    instr_code.append(instruction(index+1))             #add "m"
                    tmp_val  = "%06x" % expr_eval(i.operand)
                    instr_code[index].code = '020' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                    instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)
            else:       # i.operand[0][0]!='#' and tmp_val < 0:
                instr_code.append(instruction(index+1))             #add "m"
                tmp_val = "%06x" % ~expr_eval(i.operand)
                instr_code[index].code = '021' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)


        #023 Ai         Sj      Transmit Sj to Ai
        #This instruction enters the low order 24 bits of Sj into Ai. Ai is 
        #cleared if the j designator is 0
        elif is_a_type(i.result[0]) and is_s_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '023' + i.result[0][1] + i.operand[0][1] + '0'

        #024 Ai         Bjk     Transmit Bjk to Ai
        #This instruciton enters the contents of Bjk into Ai. A symbolic
        #B register number must be previously defined.
        elif is_a_type(i.result[0]) and is_b_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '024' + i.result[0][1] + get_jk_from_bt(i.operand[0])

        #025 Bjk        Ai      Transmit Ai to Bjk
        #This instruction enters the contents of Ai into Bjk. A symbolic
        #B register number must be previously defined.
        elif is_b_type(i.result[0]) and is_a_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '025' + i.operand[0][1] + get_jk_from_bt(i.result[0])

        #026 Ai         PSj     Population count of Sj to Ai
        #This instruction counts the number of one bits in Sj and enters
        #the result into Ai. Ai is cleared if the j designator is zero.
        elif is_a_type(i.result[0]) and len(i.operand)==1 and i.operand[0][0]=="P" and is_s_type(i.operand[0][1:]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '026' + i.result[0][1] + i.operand[0][2] + '0'

        #027 Ai         ZSj     Leading zero count of Sj to Ai
        #This instruction counts the number of leading zeroes in Sj and enters
        #the result into Ai. Ai is set to 64 if the j designator is 0.
        elif is_a_type(i.result[0]) and len(i.operand)==1 and i.operand[0][0]=="Z" and is_s_type(i.operand[0][1:]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '027' + i.result[0][1] + i.operand[0][2] + '0'

        #030 Ai         Aj+Ak   Integer sum of Aj and Ak to Ai
        #This instruction forms the integer sum of Aj and Ak and enters the
        #result into Ai. No overflow is detected. Ak is transmitted to Ai
        #when the j designator is zero and the k designator is non-zero.
        #One is transmitted to Ai when the j and k desginators are both zero.
        #(Aj)+1 is transmitted to Ai when the j designator is non-zero and
        #the k designator is zero. The assembler allows alternate forms for
        #this instruction when either j or k designator is zero
        elif is_a_type(i.result[0]) and ((len(i.operand)==3 and is_a_type(i.operand[0]) and i.operand[1]=='+' and (is_a_type(i.operand[2]) or i.operand[2]=='1')) \
                                        or (len(i.operand)==1 and is_a_type(i.operand[0]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            tmp_code = '030' + i.result[0][1]
            if len(i.operand)==3:
                if is_a_type(i.operand[2]):
                    instr_code[index].code = '030' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]
                else:
                    instr_code[index].code = '030' + i.result[0][1] + i.operand[0][1] + '0'
            elif len(i.operand)==2:
                print "Error: Incorrectly formatted integer sum - must be: Ai Aj+Ak / Ai Aj / Ai Aj+1"
                break
            else:       
                instr_code[index].code = '030' + i.result[0][1] + '0' + i.operand[0][1]

        #031 Ai         Aj-Ak   Integer difference of Aj and Ak to Ai
        #This instruction forms the integer difference of Aj and Ak and enters
        #the result into Ai. No overflow is detected. The negative of Ak is
        #transmitted to Ai when the j designator is zero and the k designator 
        # is nonzero. -1 is transmitted to Ai when the j and k designators 
        #are both zero. (Aj)-1 is transmitted to Ai when the j designator is 
        #non-zero and the k designator is zero. The assembler allows alter-
        #nate forms for this instruction when either j or k designator is zero. 
        elif is_a_type(i.result[0]) and ( (len(i.operand)==3 and is_a_type(i.operand[0]) and i.operand[1]=='-') or (len(i.operand)==2 and i.operand[0]=='-' and is_a_type(i.operand[1]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            tmp_code = '031' + i.result[0][1]
            if len(i.operand)==3:
                tmp_code = tmp_code + i.operand[0][1]
                if is_a_type(i.operand[2]):
                    tmp_code = tmp_code + i.operand[2][1]
                else:
                    tmp_code = tmp_code + '0'
            elif len(i.operand)==2:
                tmp_code = tmp_code + '0' + i.operand[1][1]
            else:
                print "Error: Incorrectly formatted integer difference - must be: Ai -Ak / Ai Aj-Ak / Ai Aj-1"
                break
            instr_code[index].code = tmp_code

        #032 Ai         Aj*Ak   Integer product of Aj and Ak to Ai      
        #This instruction forms the integer product of Aj and Ak and enters
        #the low order 24 bits of the result into Ai. No overflow is detected.
        #Ai is cleared when the j designator is zero. Aj is transmitted to Ai
        #when the k designator is zero and the j designator is non-zero.
        elif is_a_type(i.result[0]) and len(i.operand)==3 and i.operand[1]=='*':
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '032' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #033 Ai         CI      Channel number of highest priority interrupt request to Ai
        #    Ai         CA,Aj   Current address of channel (Aj) to Ai
        #    Ai         CE,Aj   Error flag of channel (Aj) to Ai
        #This instruction enters the channel status information into Ai.
        #FIXME: Implement this
        elif is_a_type(i.result[0]) and (len(i.operand)==1 and (i.operand[0]=='CI' or (len(i.operand)==3 and is_a_type(i.operand[2]) and (i.operand[0]=='CA' or i.operand[0]=='CE')))):
            print i.result
            print i.operand
            print "Not currently supported!"
            break
    

        #034 Bjk,Ai     ,A0     Read (Ai) words starting at B register jk from memory starting at (A0)
        #This instruction is used to read the low order 24 bits of words from
        #memory directly into the B registers. A0 contains the address in 
        #memory of the first word. The B register which is to receive the 
        #first word is specified by jk. Subsequent words are stored in consecutive
        #B registers. Processing of the B registers is circular.
        #B00 is processes after B77 if the count is not exhausted. The low
        #order seven bits of (Ai) specify the number of words read. A0 in
        #the operand field is optional
        elif len(i.result)==3 and is_b_type(i.result[0]) and i.result[1]==',' and is_a_type(i.result[2]) and \
            ((len(i.operand)==1 and i.operand[0]==',') or (len(i.operand)==2 and i.operand[0]==',' and i.operand[1]=='A0')):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '034' + i.result[2][1] + get_jk_from_bt(i.result[0])

        #035 ,A0        Bjk,Ai  Store (Ai) words starting at B register jk to memory starting at (A0)
        #This instruction is used to store the B registers directly into
        #memory. A0 contains the address in memory to receive the first
        #word. The B register which is stored at the first address is
        #specified by jk. Subsequent B registers are stored in consecutive
        #words in memory. Processing of b registers is circular. B00
        #is processed after B77 if the count is not exhausted. The low order
        #seven bits of (Ai) specify the number of words written. A0 in the
        #opernad field is optional
        elif len(i.operand)==3 and is_b_type(i.operand[0]) and i.operand[1]==',' and is_a_type(i.operand[2]) and \
            ((len(i.result)==1 and i.result[0]==',') or (len(i.result)==2 and i.result[0]==',' and i.result[1]=='A0')):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '035' + i.operand[2][1] + get_jk_from_bt(i.operand[0])

        #036 Tjk,Ai     ,A0     Read (Ai) words starting at T register jk from memory starting at (A0)
        #This instruction is used to read 64-bit words from memory directly     
        #into the T registers. A0 contains the address in memory of the first
        #word. The T register which is to receive the first word is specified
        #by jk. Subsequent words are stored in consecutive T registers.
        #Processing of the T registers is circular. T00 is processed after
        #T77 if the count is not exhausted. The low order 7 bits of (Ai)
        #specify the number of words read. A0 in the operand field is optional.
        elif len(i.result)==3 and is_t_type(i.result[0]) and i.result[1]==',' and is_a_type(i.result[2]) and \
            ((len(i.operand)==1 and i.operand[0]==',') or (len(i.operand)==2 and i.operand[0]==',' and i.operand[1]=='A0')):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i            
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '036' + i.result[2][1] + get_jk_from_bt(i.result[0])

        #037 ,A0        Tjk,Ai  Store (Ai) words starting at T register jk to memory starting at (A0)
        #This instruction is used to store the T registers directly into memory.
        #A0 contains the address in memory to receive the first word. The T
        #register which is stored at the first address is specified by jk.
        #Subsequent T registers are stored in consecutive words in memory.
        #Processing of the T registers is circular. T00 is processed after
        #T77 if the count is not exhausted. The low order seven bits of (Ai)
        #specify the number of words written. A0 in the operand field is optional.
        elif ((len(i.result)==1 and i.result[0]==',' and is_t_type(i.operand[0]) and i.operand[1]==',' and is_a_type(i.operand[2])) \
                or (len(i.result)==2 and i.result[0]==',' and i.result[1]=='A0' and is_t_type(i.operand[0]) and i.operand[1]==',' and is_a_type(i.operand[2]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i            
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '037' + i.operand[2][1] + get_jk_from_bt(i.operand[0])

        #040 Si         exp     Transmit jkm to Si
        #    Si         #exp    
        #041 Si         exp     Transmit jkm to Si and complement
        #    Si         #exp    
        #This two-parcel instruction enters the 22-bit quantity of the jkm
        #field into Si. The quantity is treated as a 22-bit positive integer;
        #The upper bits of Si are cleared. The assembler generates this instruction
        #when no # symbol precedes the expression and the value of 
        #the expression is positive. When the # symbol precedes the expression,
        #the expression is first evaluated and if the value is negative,
        #it is complemented and the complemented value is stored in the jkm
        #field. The complement is formed by changing all 1 bits to zero and 
        #all 0 bits to one. When the expression is positive, an 041 instruction
        #is generated.
        elif is_s_type(i.result[0]) and is_expression(i.operand)==True and not (len(i.operand)==1 and (i.operand[0]=='1' or i.operand[0]=='0')):
            instr_code.append(instruction(index))               #add the op-code + ijk
            instr_code.append(instruction(index+1))             #add "m"
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if is_defined_expression(i.operand):
                if i.operand[0][0]=='#':
                    tmp_val = expr_eval(i.operand[1:])
                else:
                    tmp_val = expr_eval(i.operand)
            else:
                tmp_val = 0
                instr_code[index].defined_location = 0

            if i.operand[0][0]=='#' and tmp_val >= 0 and tmp_val < 2097152:
                tmp_val = "%06x" % expr_eval(i.operand)
                instr_code[index].code = '041' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)
            elif i.operand[0][0]=='#' and ((tmp_val < 0) or (tmp_val > 2097152)):
                tmp_val = "%06x" % ~expr_eval(i.operand)
                instr_code[index].code = '040' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)
            elif i.operand[0][0]!='#' and tmp_val >= 0 and tmp_val < 2097152:
                tmp_val  = "%06x" % expr_eval(i.operand)
                instr_code[index].code = '040' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)
            else:       # i.operand[0][0]!='#' and tmp_val < 0:
                tmp_val = "%06x" % ~expr_eval(i.operand)
                instr_code[index].code = '041' + i.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[index+1].code = "%06o" % int(tmp_val[2:6],16)


        
        #042 Si         <exp    Form ones mask in Si from the right
        #    Si         #>exp
        #    Si         1       Special case
        #This expression is used to generate a mask of ones from the right.
        #The assembler evaluates the expression to determine the mask length.
        #If the # symbol precedes the expression the mask length is 64 minus 
        #the expression value. All symbols in the expression must be
        #previously defined. The assembler stores 64 minus the mask length
        #in the jk field of the instruction. The mask length must be a positive
        #integer not exceeding 64. If the mask length is zero, an 043 
        #instruction is generated.
        #
        #043 Si         >exp    Form ones mask in Si from the left
        #    Si         #<exp
        #    Si         0       Special case
        #This instruction is used to generate a mask of ones from the left.
        #The assembler evaluates the expression to determine the mask length.
        #If the # symbol precedes the expression the mask length is 64 minus 
        #the expression value. All symbols in the expression must be 
        #previously defined. The assembler stores the mask length in the
        #jk field of the instruction. The mask length must be a positive
        #integer not exceeding 64. If the mask length is 64, an 042 instruction
        #is generated.
        elif is_s_type(i.result[0]) and ( (len(i.operand)==2 and (i.operand[0]=='<' or i.operand[0]=='>') and is_expression(i.operand[1:])) \
                                        or (len(i.operand)==3 and i.operand[0]=='#' and (i.operand[1]=='<' or i.operand[1]=='>') and is_expression(i.operand[2:])) \
                                        or (len(i.operand)==1 and (i.operand[0]=='0' or i.operand[0]=='1'))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if i.operand[0]=='#':
                if is_defined_expression(i.operand[2:]):
                    tmp_val = 64-expr_eval(i.operand[2:])
                else:
                    tmp_val = 0
                    instr_code[index].defined_location = 0
            elif i.operand[0]=='0':                     #detect special case
                tmp_val = 0
            elif i.operand[0]=='1':                     #detect special case
                tmp_val = 1
            else:
                if is_defined_expression(i.operand[1:]):
                    tmp_val = expr_eval(i.operand[1:])
                else:
                    tmp_val = 0
                    instr_code[index].defined_location = 0

            if tmp_val > 64 or tmp_val < 0:
                print "Error! cannot form mask if mask_length = " + str(tmp_val)
                break
            elif i.operand[0]=='<' or (i.operand[0]=='#' and i.operand[1]=='>'):
                if tmp_val == 0:
                    tmp_code = '043' + i.result[0][1] + '00'
                else:
                    tmp_code = '042' + i.result[0][1] + "%02o" % (64 - tmp_val)
            else:
                if tmp_val == 64:
                    tmp_code = '042' + i.result[0][1] + '00'
                elif tmp_val == 1:
                    tmp_code = '042' + i.result[0][1] + '77'
                else:
                    tmp_code = '043' + i.result[0][1] + "%02o" % (tmp_val)
            instr_code[index].code = tmp_code;

        #044 Si         Sj&Sk   Logical product of Sj and Sk to Si
        #This instruction forms the logical product (AND) of Sj and Sk and
        #enters the result into Si.
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='&' and is_s_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '044' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #045 Si         #Sk&Sj   Logical product of Sj and complement of Sk to Si
        #This instruction forms the logical product (AND) of Sj and the complement
        #of Sk and enters the result into Si.
        elif is_s_type(i.result[0]) and (len(i.operand)==4 and i.operand[0]=='#' and is_s_type(i.operand[1]) and i.operand[2]=='&' and is_s_type(i.operand[3])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '045' + i.result[0][1] + i.operand[3][1] + i.operand[1][1]

        #046 Si         Sj\Sk   Logical difference of Sj and Sk to Si
        #This instruction forms the logical difference (XOR) of Sj 
        #and Sk and enters the result into Si.
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='\\' and is_s_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '046' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #047 Si         #Sj\Sk  Logical difference of ~Sj and Sk to Si

        elif is_s_type(i.result[0]) and ((len(i.operand)==4 and i.operand[0]=='#' and is_s_type(i.operand[1]) and i.operand[2]=='\\' and is_s_type(i.operand[3])) \
                                        or (len(i.operand)==2 and i.operand[0]=='#' and is_s_type(i.operand[1]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.operand)==4:
                instr_code[index].code = '047' + i.result[0][1] + i.operand[1][1] + i.operand[3][1]
            else:
                instr_code[index].code = '047' + i.result[0][1] + '0' + i.operand[1][1]

        #050 Si         Sj!Si&Sk
        #This instruction merges the contents of Sj with Si depending on the ones mask in Sk.
        elif is_s_type(i.result[0]) and (len(i.operand)==5 and is_s_type(i.operand[0]) and i.operand[1]=='!' and i.result[0]==i.operand[2] and i.operand[3]=='&' and is_s_type(i.operand[4])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '050' + i.result[0][1] + i.operand[0][1] + i.operand[4][1]
            
        #051 Si         Sj!Sk   Logical sum (inclusive OR) of Sj and Sk to Si
        elif is_s_type(i.result[0]) and ((len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='!' and is_s_type(i.operand[2])) \
                                        or (len(i.operand)==1 and is_s_type(i.operand[0]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.operand)==3:
                instr_code[index].code = '051' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]
            else:
                instr_code[index].code = '051' + i.result[0][1] + '0' + i.operand[0][1]

        #052 S0         Si<exp   Shift Si left jk places to S0
        elif i.result[0]=='S0' and (len(i.operand)!=1 and is_s_type(i.operand[0]) and i.operand[1]=='<' and is_expression(i.operand[2:])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if is_defined_expression(i.operand[2:]):
                tmp_val = "%02o" % expr_eval(i.operand[2:])
                if expr_eval(i.operand[2:])==64:
                    instr_code[index].code = '053' + i.operand[0][1] + tmp_val[len(tmp_val)-2:len(tmp_val)]
                else:
                    instr_code[index].code = '052' + i.operand[0][1] + tmp_val[len(tmp_val)-2:len(tmp_val)]
            else:
                tmp_val = 0
                instr_code[index].defined_location = 0
                instr_code[index].code = '052' + i.operand[0][1] + tmp_val[len(tmp_val)-2:len(tmp_val)] 
                

        #053 S0         Si>exp   Shift Si right 64-jk places to S0
        elif i.result[0]=='S0' and (len(i.operand)!=1 and is_s_type(i.operand[0]) and i.operand[1]=='>' and is_expression(i.operand[2:])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if expr_eval(i.operand[2:])==0:
                instr_code[index].code = '052' + i.operand[0][1] + '00'
            else:
                instr_code[index].code = '053' + i.operand[0][1] + "%02o" % (64-expr_eval(i.operand[2:]))

        #054 Si         Si<exp  Shift Si left jk places to Si
        elif is_s_type(i.result[0]) and i.result[0]==i.operand[0]  and (len(i.operand)!=1 and i.operand[1]=='<' and is_expression(i.operand[2:])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if expr_eval(i.operand[2:])==64:
                 instr_code[index].code = '055' + i.operand[0][1] + '00'
            else:
                instr_code[index].code = '054' + i.operand[0][1] + "%02o" % expr_eval(i.operand[2:])

        #055 Si         Si>exp  Shift Si right 64-jk places to Si
        elif is_s_type(i.result[0]) and i.result[0]==i.operand[0]  and (len(i.operand)!=1 and i.operand[1]=='>' and is_expression(i.operand[2:])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if expr_eval(i.operand[2:])==0:
                instr_code[index].code = '054' + i.operand[0][1] + '00'
            else:
                instr_code[index].code = '055' + i.operand[0][1] + "%02o" % (64-expr_eval(i.operand[2:]))

        #056 Si         Si,Sj<Ak   Shift Si Sj left (Ak) places to Si
        elif is_s_type(i.result[0]) and ((len(i.operand)==5 and i.result[0]==i.operand[0] and i.operand[1]==',' and is_s_type(i.operand[2]) and i.operand[3]=='<' and is_a_type(i.operand[4])) \
                                        or (len(i.operand)==3 and i.result[0]==i.operand[0] and i.operand[1]=='<' and is_a_type(i.operand[2]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.operand)==5:
                instr_code[index].code = '056' + i.result[0][1] + i.operand[2][1] + i.operand[4][1]
            else:
                instr_code[index].code = '056' + i.result[0][1] + '0' + i.operand[2][1]

        #057 Si         Sj,Si>Ak   Shift Sj Si right (Ak) places to Si
        elif is_s_type(i.result[0]) and ((len(i.operand)==5 and i.result[0]==i.operand[2] and i.operand[1]==',' and is_s_type(i.operand[0]) and i.operand[3]=='>' and is_a_type(i.operand[4])) \
                                        or (len(i.operand)==3 and i.result[0]==i.operand[0] and i.operand[1]=='>' and is_a_type(i.operand[2]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.operand)==5:
                instr_code[index].code = '057' + i.result[0][1] + i.operand[0][1] + i.operand[4][1]
            else:
                instr_code[index].code = '057' + i.result[0][1] + '0' + i.operand[2][1]

        #060 Si         Sj+Sk   Integer sum of Sj and Sk to Si
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='+' and is_s_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '060' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #061 Si         Sj-Sk   Integer difference of Sj and Sk to Si
        elif is_s_type(i.result[0]) and ((len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='-' and is_s_type(i.operand[2])) \
                                        or (len(i.operand)==2 and i.operand[0]=='-' and is_s_type(i.operand[1]))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.operand)==3:
                instr_code[index].code = '061' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]
            else:
                instr_code[index].code = '061' + i.result[0][1] + '0' + i.operand[1][1]

        #062 Si         Sj+FSk  Floating sum of Sj and Sk to Si
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='+' and is_fs_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '062' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #063 Si         Sj-FSk  Floating difference of Sj and Sk to Si
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='-' and is_fs_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '063' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #064 Si         Sj*FSk  Floating product of Sj and Sk to Si
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_fs_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '064' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #065 Si         Sj*HSk  Half-precision rounded floating product of Sj and Sk to Si
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_hs_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '065' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #066 Si         Sj*RSk  Rounded floating product of Sj and Sk to Si
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_rs_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '066' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #067 Si         Sj*ISk  Reciprocal Iteration
        elif is_s_type(i.result[0]) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_is_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '067' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #070 Si         /HSj    Floating reciprocal approximation of Sj to Si
        elif is_s_type(i.result[0]) and (len(i.operand)==2 and i.operand[0]=='/' and is_hs_type(i.operand[1])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '070' + i.result[0][1] + i.operand[1][2] + '0'

        #071 Si         Ak      Transmit Ak to Si with no sign extension
        #    Si         +Ak     Transmit Ak to Si with sign extension
        #    Si         +FAk    Transmit Ak to Si as unnormalized floating point
        #    Si         0.6     Transmit constant .75*2**48 to Si
        #    Si         0.4     Transmit constant .5 to Si
        #    Si         1.      Transmit constant 1. to Si
        #    Si         2.      Transmit constant 2. to Si
        #    Si         4.      Transmit constant 4. to Si
        elif is_s_type(i.result[0]) and ( (len(i.operand)==1 and (is_a_type(i.operand[0]) or i.operand[0] in ['0.6','0.4','1.','2.','4.'])) \
                                       or (len(i.operand)==2 and i.operand[0]=='+' and (is_a_type(i.operand[1]) or is_fa_type(i.operand[1])))):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if(len(i.operand)==2):                      #going to be a +Ak or +FAk
                if is_a_type(i.operand[1]):             #+Ak
                    instr_code[index].code = '071' + i.result[0][1] + '1' + i.operand[1][1]
                else:                                   #+FAk
                    instr_code[index].code = '071' + i.result[0][1] + '2' + i.operand[1][2]
            else:
                if is_a_type(i.operand[0]):
                    instr_code[index].code = '071' + i.result[0][1] + '0' + i.operand[0][1]
                elif i.operand[0]=='0.6':
                    instr_code[index].code = '071' + i.result[0][1] + '3' + '0'
                elif i.operand[0]=='0.4':
                    instr_code[index].code = '071' + i.result[0][1] + '4' + '0'
                elif i.operand[0]=='1.':
                    instr_code[index].code = '071' + i.result[0][1] + '5' + '0'
                elif i.operand[0]=='2.':
                    instr_code[index].code = '071' + i.result[0][1] + '6' + '0'
                elif i.operand[0]=='4.':
                    instr_code[index].code = '071' + i.result[0][1] + '7' + '0'

        #072 Si         RT      Transmit RTC to Si
        elif is_s_type(i.result[0]) and len(i.operand)==1 and i.operand[0]=='RT':
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '072' + i.result[0][1] + '00'

        #073 Si         VM      Transmit Vector Mask to Si
        elif is_s_type(i.result[0]) and len(i.operand)==1 and i.operand[0]=='VM':
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '073' + i.result[0][1] + '00'

        #074 Si         Tjk     Transmit Tjk to Si
        elif is_s_type(i.result[0]) and len(i.operand)==1 and is_t_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '074' + i.result[0][1] + get_jk_from_bt(i.operand[0])

        #075 Tjk        Si      Transmit Si to Tjk
        elif is_t_type(i.result[0]) and len(i.operand)==1 and is_s_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '075' + i.operand[0][1] + get_jk_from_bt(i.result[0])

        #076 Si         Vj,Ak   Transmit Vj element (Ak) to Si
        elif is_s_type(i.result[0]) and len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]==',' and is_a_type(i.operand[2]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '076' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #077 Vi,Ak      Sj      Transmit Sj to Vi element (Ak)
        elif len(i.result)==3 and is_v_type(i.result[0]) and i.result[1]==',' and is_a_type(i.result[2]) and len(i.operand)==1 and is_s_type(i.operand[0]):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '077' + i.result[0][1] + i.operand[0][1] + i.result[2][1]

        #10h Ai         exp,Ah  Read from (Ah)+jkm to Ai
        elif (len(i.result)==1 and is_a_type(i.result[0])) and (len(i.operand)>2 and \
            is_expression(i.operand[:len(i.operand)-2]) and i.operand[len(i.operand)-2]==',' and (is_a_type(i.operand[len(i.operand)-1]) or i.operand[len(i.operand)-1]=='0')):  
            instr_code.append(instruction(index))
            instr_code.append(instruction(index+1))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            if is_defined_expression(i.operand[:len(i.operand)-2]):
                hex_jkm = "%06x" % (expr_eval(i.operand[:len(i.operand)-2]) % 0x400000)
            else:
                instr_code[index].defined_location = 0
                hex_jkm = "%06x" % 0
            #then break off the top two digits and convert them to a 2-digit octal string for jk
            if i.operand[len(i.operand)-1]=='0':
                instr_code[index].code = '10' + '0' + i.result[0][1] + "%02o" % (int(hex_jkm[0:2],16) & 0x3F)
            else:
                instr_code[index].code = '10' + i.operand[len(i.operand)-1][1] + i.result[0][1] + "%02o" % int(hex_jkm[0:2],16)
                
            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[index+1].code = "%06o" % int(hex_jkm[2:],16)

        #11h exp,Ah     Ai      Store Ai to (Ah)+jkm
        elif (len(i.operand)==1 and is_a_type(i.operand[0])) and (len(i.result)>2 and is_expression(i.result[:len(i.result)-2]) and i.result[len(i.result)-2]==',' and \
             (is_a_type(i.result[len(i.result)-1]) or i.result[len(i.result)-1]=='0')):
            instr_code.append(instruction(index))
            instr_code.append(instruction(index+1))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            if is_defined_expression(i.result[:len(i.result)-2]):
                hex_jkm = "%06x" % (expr_eval(i.result[:len(i.result)-2]) % 0x400000)
            else:
                    instr_code[index].defined_location = 0
                    hex_jkm = "%06x" % 0
            #then break off the top two digits and convert them to a 2-digit octal string for jk
            if i.result[len(i.result)-1]=='0':
                instr_code[index].code = '11' + '0' + i.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            else:
                instr_code[index].code = '11' + i.result[len(i.result)-1][1] + i.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[index+1].code = "%06o" % int(hex_jkm[2:],16)

        #12h Si         exp,Ah  Read from (Ah)+jkm to Si
        elif (len(i.result)==1 and is_s_type(i.result[0])) and (len(i.operand)>2 and is_expression(i.operand[:len(i.operand)-2]) and i.operand[len(i.operand)-2]==',' and \
             (is_a_type(i.operand[len(i.operand)-1])) or i.operand[len(i.operand)-1]=='0'):
            instr_code.append(instruction(index))
            instr_code.append(instruction(index+1))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            if is_defined_expression(i.result[:len(i.operand)-2]):
                hex_jkm = "%06x" % (expr_eval(i.operand[:len(i.operand)-2]) % 0x400000)
            else:
                instr_code[index].defined_location = 0
                hex_jkm = "%06x" % 0
            #then break off the top two digits and convert them to a 2-digit octal string for jk
            if i.operand[len(i.operand)-1]=='0':
                instr_code[index].code = '12' + '0' + i.result[0][1] + "%02o" % int(hex_jkm[0:2],16)
            else:
                instr_code[index].code = '12' + i.operand[len(i.operand)-1][1] + i.result[0][1] + "%02o" % int(hex_jkm[0:2],16)
            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[index+1].code = "%06o" % int(hex_jkm[2:],16)

        #13h exp,Ah     Si      Store Si to (Ah)+jkm
        elif (len(i.operand)==1 and is_s_type(i.operand[0])) and (len(i.result)>2 and is_expression(i.result[:len(i.result)-2]) and i.result[len(i.result)-2]==',' and \
              (is_a_type(i.result[len(i.result)-1])) or i.result[len(i.result)-1]=='0'):
            instr_code.append(instruction(index))
            instr_code.append(instruction(index+1))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            if is_defined_expression(i.result[:len(i.result)-2]):
                hex_jkm = "%06x" % (expr_eval(i.result[:len(i.result)-2]) % 0x400000)
            else:
                instr_code[index].defined_location = 0
                hex_jkm = "%06x" % 0
            #then break off the top two digits and convert them to a 2-digit octal string for jk
            if i.result[len(i.result)-1]=='0':
                instr_code[index].code = '13' + '0' + i.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            else:
                instr_code[index].code = '13' + i.result[len(i.result)-1][1] + i.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[index+1].code = "%06o" % int(hex_jkm[2:],16)

        #140 Vi         Sj&Vk   Logical product of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='&' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '140' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #141 Vi         Vj&Vk   Logical product of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='&' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '141' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #142 Vi         Sj!Vk   Logical sum of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='!' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '142' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #143 Vi         Vj!Vk   Logical sum of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='!' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '143' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #144 Vi         Sj\Vk   Logical difference of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='\\' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '144' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #145 Vi         Vj\Vk   Logical difference of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='\\' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '145' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #146 Vi         Sj!Vk&VM        Vector Merge
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==5 and is_s_type(i.operand[0]) and i.operand[1]=='!' and is_v_type(i.operand[2]) and i.operand[3]=='&' and i.operand[4]=='VM'):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '146' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #147 Vi         Vj!Vk&VM        Vector Merge
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==5 and is_v_type(i.operand[0]) and i.operand[1]=='!' and is_v_type(i.operand[2]) and i.operand[3]=='&' and i.operand[4]=='VM'):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '147' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #150 Vi         Vj<Ak   Shift Vj left (Ak) places to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='<' and is_a_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i            
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '150' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #151 Vi         Vj>Ak   Shift Vj right (Ak) places to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='>' and is_a_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i            
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '151' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #152 Vi         Vj,Vj<Ak        Double shift Vj left (Ak) places to Vi    
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==5 and is_v_type(i.operand[0]) and i.operand[1]==',' and is_v_type(i.operand[2]) and i.operand[0]==i.operand[2] and i.operand[3]=='<' and is_a_type(i.operand[4])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i            
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '152' + i.result[0][1] + i.operand[0][1] + i.operand[4][1]
        
        #153 Vi         Vj,Vj>Ak        Double shift Vj right (Ak) places to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==5 and is_v_type(i.operand[0]) and i.operand[1]==',' and is_v_type(i.operand[2]) and i.operand[0]==i.operand[2] and i.operand[3]=='>' and is_a_type(i.operand[4])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '153' + i.result[0][1] + i.operand[0][1] + i.operand[4][1]

        #154 Vi         Sj+Vk   Integer sum of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='+' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '154' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #155 Vi         Vj+Vk   Integer sum of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='+' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '155' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #156 Vi         Sj-Vk   Integer difference of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='-' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '156' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #157 Vi         Vj-Vk   Integer difference of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='-' and is_v_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '157' + i.result[0][1] + i.operand[0][1] + i.operand[2][1]

        #160 Vi         Sj*FVk  Floating product of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_fv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '160' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #161 Vi         Vj*FVk  Floating product of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='*' and is_fv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '161' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #162 Vi         Sj*HVk  Half-precision rounded floating product of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_hv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '162' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #163 Vi         Vj*HVk  Half-precision rounded floating product of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='*' and is_hv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '163' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #164 Vi         Sj*RVk  Rounded floating product of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_rv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '164' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #165 Vi         Vj*RVk  Rounded floating product of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='*' and is_rv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '165' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #166 Vi         Sj*IVk  Reciprocal Iteration
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='*' and is_iv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '166' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #167 Vi         Vj*IVk  Reciprocal Iteration
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='*' and is_iv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '167' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #170 Vi         Sj+FVk  Floating sum of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='+' and is_fv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '170' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #171 Vi         Vj+FVk  Floating sum of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='+' and is_fv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '171' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #172 Vi         Sj-FVk  Floating difference of Sj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_s_type(i.operand[0]) and i.operand[1]=='-' and is_fv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '172' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #173 Vi         Vj-FVk  Floating difference of Vj and Vk to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]=='-' and is_fv_type(i.operand[2])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '173' + i.result[0][1] + i.operand[0][1] + i.operand[2][2]

        #174 Vi         /HVj    Floating reciprocal approximation of Vj to Vi
        elif (len(i.result)==1 and is_v_type(i.result[0])) and (len(i.operand)==2 and i.operand[0]=='/' and is_hv_type(i.operand[1])):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            instr_code[index].code = '174' + i.result[0][1] + i.operand[1][2] + '0'

        #175 VM         Vj,[Z,N,P,M]    Form mask on Vj as defined by k in VM
        elif (len(i.result)==1 and i.result[0]=='VM') and (len(i.operand)==3 and is_v_type(i.operand[0]) and i.operand[1]==',' and i.operand[2] in ['Z','N','P','M']):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            vector_mask_type = {'Z':'0','N':'1','P':'2','M':'3'}
            instr_code[index].code = '175' + '0' + i.operand[0][1] + vector_mask_type[i.operand[2]]

        #176 Vi         ,A0,Ak  Read VL words to Vi from memory starting at (A0) incremented by (Ak)
        elif (len(i.result)==1 and is_v_type(i.result[0])) and  ( \
                (len(i.operand)==4 and i.operand[0]==',' and i.operand[1]=='A0' and i.operand[2]==',' and is_a_type(i.operand[3])) \
                or (len(i.operand)==3 and i.operand[0]==',' and i.operand[1]==',' and is_a_type(i.operand[2])) \
                or (len(i.operand)==3 and i.operand[0]==',' and i.operand[1]==',' and i.operand[2]=='1') ):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.operand)==4:
                instr_code[index].code = '176' + i.result[0][1] + '0' + i.operand[3][1]
            else:
                if i.operand[2]=='1':
                    instr_code[index].code = '176' + i.result[0][1] + '0' + '0'
                else:
                    instr_code[index].code = '176' + i.result[0][1] + '0' + i.operand[2][1]
    
        #177 ,A0,Ak     Vj      Store VL words from Vj to memory starting at (A0) incremented by (Ak)
        elif (len(i.operand)==1 and is_v_type(i.operand[0])) and ( \
                (len(i.result)==4 and i.result[0]==',' and i.result[1]=='A0' and i.result[2]==',' and is_a_type(i.result[3])) \
                or (len(i.result)==3 and i.result[0]==',' and i.result[1]==',' and is_a_type(i.result[2])) \
                or (len(i.result)==3 and i.result[0]==',' and i.result[1]==',' and i.result[2]=='1') ):
            instr_code.append(instruction(index))
            instr_code[index].instruction = i
            if i.location != "":
                locations[i.location]=index + program_origin
            if len(i.result)==4:
                instr_code[index].code = '177' + '0' + i.operand[0][1] +  i.result[3][1]
            else:
                if i.result[2]=='1':
                    instr_code[index].code = '177' + '0' + i.operand[0][1] + '0'
                else:
                    instr_code[index].code = '177' + '0' + i.operand[0][1] + i.result[2][1]


        else:
            print i.result
            print i.operand
            print "Instruction currently not decoded"         
            undecoded_instructions = undecoded_instructions + 1


#Now, we need to go back through all of the instructions that might have
#had undefined expressions in them, and calculate those expressions


for i in range(0,len(instr_code)):
    if instr_code[i].defined_location==0:
        #006 J      exp     Branch to ijkm
        if instr_code[i].instruction.result[0] == "J" and is_b_type(instr_code[i].instruction.operand[0]) == False:
            tmp_code = "006"
            tmp_val = "%06x" % expr_eval(instr_code[i].instruction.operand)     #tmp_val now holds the destination as a 6-digit hex string value                
            mval    = "%06o" % int(tmp_val[2:6],16)     #figure out the lowest 16 bits of the destination (the "M" value), and convert to 6-digit octal
            instr_code[i+1].code = mval             #write out the 6-digit octal value as the following 16-bit instruction
            tmp_code = tmp_code + "%03o" % int(tmp_val[0:2],16) #now write out the remaining part of the address as the lower 9 bits of the jump-instruction
            instr_code[i].code = tmp_code

        #007 R     exp     Return jump to ijkm
        elif instr_code[i].instruction.result[0] == "R":
            tmp_code = "007"
            tmp_val = "%06x" % expr_eval(instr_code[i].instruction.operand)     #tmp_val now holds the destination as a 6-digit hex string value
            mval    = "%06o" % int(tmp_val[2:6],16)     #figure out the lowest 16 bits of the destination (the "M" value), and convert to 6-digit octal
            instr_code[i+1].code = mval             #write out the 6-digit octal value as the following 16-bit instruction
            tmp_code = tmp_code + "%03o" % int(tmp_val[0:2],16) #now write out the remaining part of the address as the lower 9 bits of the jump-instruction
            instr_code[i].code = tmp_code
        elif instr_code[i].instruction.result[0] in ["JAZ","JAN","JAP","JAM","JSZ","JSN","JSP","JSM"]:
            if instr_code[i].instruction.result[0]=="JAZ":
                tmp_code = "010"
            elif instr_code[i].instruction.result[0]=="JAN":
                tmp_code = "011"
            elif instr_code[i].instruction.result[0]=="JAP":
                tmp_code = "012"
            elif instr_code[i].instruction.result[0]=="JAM":
                tmp_code = "013"
            elif instr_code[i].instruction.result[0]=="JSZ":
                tmp_code = "014"
            elif instr_code[i].instruction.result[0]=="JSN":
                tmp_code = "015"
            elif instr_code[i].instruction.result[0]=="JSP":
                tmp_code = "016"
            else:       #JSM
                tmp_code = "017"
            print instr_code[i].instruction.comments 
            tmp_val = "%06x" % expr_eval(instr_code[i].instruction.operand)     #tmp_val now holds the destination as a 6-digit hex string value
            mval    = "%06o" % int(tmp_val[2:6],16)     #figure out the lowest 16 bits of the destination (the "M" value), and convert to 6-digit octal
            instr_code[i+1].code = mval             #write out the 6-digit octal value as the following 16-bit instruction
            tmp_code = tmp_code + "%03o" % int(tmp_val[0:2],16) #now write out the remaining part of the address as the lower 9 bits of the jump-instruction
            instr_code[i].code = tmp_code

        #020 Ai         exp     Transmit jkm to Ai
        #    Ai         #exp    
        #021 Ai         exp     Transmit jkm to Ai and complement
        #021 Ai         #exp
        elif is_a_type(instr_code[i].instruction.result[0]) and is_expression(instr_code[i].instruction.operand)==True:
            if instr_code[i].instruction.operand[0][0]=='#':
                tmp_val = expr_eval(instr_code[i].instruction.operand[1:])
            else:
                tmp_val = expr_eval(instr_code[i].instruction.operand)
            
            if instr_code[i].instruction.operand[0][0]=='#' and tmp_val >= 0 and tmp_val < 2097152:
                tmp_val = "%06x" % expr_eval(i.operand)
                instr_code[i].code = '021' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)
            elif instr_code[i].instruction.operand[0][0]=='#' and ((tmp_val < 0) or (tmp_val > 2097152)):
                tmp_val = "%06x" % ~expr_eval(instr_code[i].instruction.operand)
                instr_code[i].code = '020' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)
            elif instr_code[i].instruction.operand[0][0]!='#' and tmp_val >= 0 and tmp_val < 2097152:             
                tmp_val  = "%06x" % expr_eval(instr_code[i].instruction.operand)
                instr_code[i].code = '020' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)
            else:       # i.operand[0][0]!='#' and tmp_val < 0:
                tmp_val = "%06x" % ~expr_eval(instr_code[i].instruction.operand)
                instr_code[i].code = '021' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)
 
        #040 Si         exp     Transmit jkm to Si
        #    Si         #exp    
        #041 Si         exp     Transmit jkm to Si and complement
        #    Si         #exp    
        elif is_s_type(instr_code[i].instruction.result[0]) and \
             is_expression(instr_code[i].instruction.operand)==True and not \
             (len(instr_code[i].instruction.operand)==1 and \
             (instr_code[i].instruction.operand[0]=='1' or instr_code[i].instruction.operand[0]=='0')):

            if instr_code[i].instruction.operand[0][0]=='#':
                tmp_val = expr_eval(instr_code[i].instruction.operand[1:])
            else:
                tmp_val = expr_eval(instr_code[i].instruction.operand)
          
            if instr_code[i].instruction.operand[0][0]=='#' and tmp_val >= 0 and tmp_val < 2097152:
                tmp_val = "%06x" % expr_eval(instr_code[i].instruction.operand)
                instr_code[i].code = '041' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)
            elif instr_code[i].instruction.operand[0][0]=='#' and ((tmp_val < 0) or (tmp_val > 2097152)):
                tmp_val = "%06x" % ~expr_eval(instr_code[i].instruction.operand)
                instr_code[i].code = '040' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)
            elif instr_code[i].instruction.operand[0][0]!='#' and tmp_val >= 0 and tmp_val < 2097152:
                tmp_val  = "%06x" % expr_eval(instr_code[i].instruction.operand)
                instr_code[i].code = '040' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)
            else:       # i.operand[0][0]!='#' and tmp_val < 0:
                tmp_val = "%06x" % ~expr_eval(instr_code[i].instruction.operand)
                instr_code[i].code = '041' + instr_code[i].instruction.result[0][1] + "%02o" % (int((tmp_val[0:2]),16) & 0x3f)
                instr_code[i+1].code = "%06o" % int(tmp_val[2:6],16)


        
        #042 Si         <exp    Form ones mask in Si from the right
        #    Si         #>exp
        #    Si         1       Special case
        #043 Si         >exp    Form ones mask in Si from the left
        #    Si         #<exp
        #    Si         0       Special case
        elif is_s_type(instr_code[i].instruction.result[0]) and ( (len(instr_code[i].instruction.operand)==2 and \
            (instr_code[i].instruction.operand[0]=='<' or instr_code[i].instruction.operand[0]=='>') and is_expression(instr_code[i].instruction.operand[1:])) \
             or (len(instr_code[i].instruction.operand)==3 and instr_code[i].instruction.operand[0]=='#' and \
            (instr_code[i].instruction.operand[1]=='<' or instr_code[i].instruction.operand[1]=='>') and is_expression(instr_code[i].instruction.operand[2:])) \
            or (len(instr_code[i].instruction.operand)==1 and (instr_code[i].instruction.operand[0]=='0' or instr_code[i].instruction.operand[0]=='1'))):
   
            if instr_code[i].instruction.operand[0]=='#':
                tmp_val = 64-expr_eval(instr_code[i].instruction.operand[2:])   
            elif instr_code[i].instruction.operand[0]=='0':                     #detect special case
                tmp_val = 0
            elif instr_code[i].instruction.operand[0]=='1':                     #detect special case
                tmp_val = 1
            else:
                tmp_val = expr_eval(instr_code[i].instruction.operand[1:])

            if tmp_val > 64 or tmp_val < 0:
                print "Error! cannot form mask if mask_length = " + str(tmp_val)
                break
            elif instr_code[i].instruction.operand[0]=='<' or (instr_code[i].instruction.operand[0]=='#' and instr_code[i].instruction.operand[1]=='>'):
                if tmp_val == 0:
                    tmp_code = '043' + instr_code[i].instruction.result[0][1] + '00'
                else:
                    tmp_code = '042' + instr_code[i].instruction.result[0][1] + "%02o" % (64 - tmp_val)
            else:
                if tmp_val == 64:
                    tmp_code = '042' + instr_code[i].instruction.result[0][1] + '00'
                elif tmp_val == 1:
                    tmp_code = '042' + instr_code[i].instruction.result[0][1] + '77'
                else:
                    tmp_code = '043' + instr_code[i].instruction.result[0][1] + "%02o" % (tmp_val)
            instr_code[i].code = tmp_code;


        #052 S0         Si<exp   Shift Si left jk places to S0
        elif instr_code[i].instruction.result[0]=='S0' and (len(instr_code[i].instruction.operand)!=1 and \
            is_s_type(instr_code[i].instruction.operand[0]) and instr_code[i].instruction.operand[1]=='<' and \
            is_expression(instr_code[i].instruction.operand[2:])):
            tmp_val = "%02o" % expr_eval(instr_code[i].instruction.operand[2:])
            if expr_eval(instr_code[i].instruction.operand[2:])==64:
                instr_code[i].code = '053' + instr_code[i].instruction.operand[0][1] + tmp_val[len(tmp_val)-2:len(tmp_val)]
            else:
                instr_code[i].code = '052' + instr_code[i].instruction.operand[0][1] + tmp_val[len(tmp_val)-2:len(tmp_val)]
                
        #053 S0         Si>exp   Shift Si right 64-jk places to S0
        elif instr_code[i].instruction.result[0]=='S0' and (len(instr_code[i].instruction.operand)!=1 and \
            is_s_type(instr_code[i].instruction.operand[0]) and instr_code[i].instruction.operand[1]=='>' and \
            is_expression(instr_code[i].instruction.operand[2:])):
            if expr_eval(instr_code[i].instruction.operand[2:])==0:
                instr_code[i].code = '052' + instr_code[i].instruction.operand[0][1] + '00'
            else:
                instr_code[i].code = '053' + instr_code[i].instruction.operand[0][1] + "%02o" % (64-expr_eval(instr_code[i].instruction.operand[2:]))

        #054 Si         Si<exp  Shift Si left jk places to Si
        elif is_s_type(instr_code[i].instruction.result[0]) and instr_code[i].instruction.result[0]==instr_code[i].instruction.operand[0] and \
             (len(instr_code[i].instruction.operand)!=1 and instr_code[i].instruction.operand[1]=='<' and is_expression(instr_code[i].instruction.operand[2:])):
            if expr_eval(instr_code[i].instruction.operand[2:])==64:
                 instr_code[i].code = '055' + instr_code[i].instruction.operand[0][1] + '00'
            else:
                instr_code[i].code = '054' + instr_code[i].instruction.operand[0][1] + "%02o" % expr_eval(instr_code[i].instruction.operand[2:])

        #055 Si         Si>exp  Shift Si right 64-jk places to Si
        elif is_s_type(instr_code[i].instruction.result[0]) and instr_code[i].instruction.result[0]==instr_code[i].instruction.operand[0] and \
             (len(instr_code[i].instruction.operand)!=1 and instr_code[i].instruction.operand[1]=='>' and is_expression(instr_code[i].instruction.operand[2:])):
            if expr_eval(instr_code[i].instruction.operand[2:])==0:
                instr_code[i].code = '054' + instr_code[i].instruction.operand[0][1] + '00'
            else:
                instr_code[i].code = '055' + instr_code[i].instruction.operand[0][1] + "%02o" % (64-expr_eval(instr_code[i].instruction.operand[2:]))


        #10h Ai         exp,Ah  Read from (Ah)+jkm to Ai
        elif (len(instr_code[i].instruction.result)==1 and is_a_type(instr_code[i].instruction.result[0])) and \
             (len(instr_code[i].instruction.operand)>2 and is_expression(instr_code[i].instruction.operand[:len(instr_code[i].instruction.operand)-2]) and \
              instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-2]==',' and \
              (is_a_type(instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1]) or instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1]=='0')):  
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            hex_jkm = "%06x" % expr_eval(i.operand[:len(i.operand)-2])
            #then break off the top two digits and convert them to a 2-digit octal string for jk 
            if instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1]=='0':
                instr_code[i].code = '10' + '0' + instr_code[i].instruction.result[0][1] + "%02o" % int(hex_jkm[0:2],16)
            else:
                instr_code[i].code = '10' + instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1][1] + \
                                 instr_code[i].instruction.result[0][1] + "%02o" % int(hex_jkm[0:2],16)

            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[i+1].code = "%06o" % int(hex_jkm[2:],16)

        #11h exp,Ah     Ai      Store Ai to (Ah)+jkm
        elif (len(instr_code[i].instruction.operand)==1 and is_a_type(instr_code[i].instruction.operand[0])) and \
             (len(instr_code[i].instruction.result)>2 and is_expression(instr_code[i].instruction.result[:len(instr_code[i].instruction.result)-2]) and \
              instr_code[i].instruction.result[len(instr_code[i].instruction.result)-2]==',' and \
              (is_a_type(instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1]) or instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1]=='0')):
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            hex_jkm = "%06x" % expr_eval(instr_code[i].instruction.result[:len(instr_code[i].instruction.result)-2])
            #then break off the top two digits and convert them to a 2-digit octal string for jk
            if instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1]=='0':
                instr_code[i].code = '11' + '0'  + instr_code[i].instruction.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            else:
                instr_code[i].code = '11' + instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1][1] \
                                 + instr_code[i].instruction.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[i+1].code = "%06o" % int(hex_jkm[2:],16)

        #12h Si         exp,Ah  Read from (Ah)+jkm to Si
        elif (len(instr_code[i].instruction.result)==1 and is_s_type(instr_code[i].instruction.result[0])) and \
             (len(instr_code[i].instruction.operand)>2 and is_expression(instr_code[i].instruction.operand[:len(instr_code[i].instruction.operand)-2]) and \
              instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-2]==',' and \
              (is_a_type(instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1]) or instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1]=='0')):
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            hex_jkm = "%06x" % expr_eval(instr_code[i].instruction.operand[:len(instr_code[i].instruction.operand)-2])
            #then break off the top two digits and convert them to a 2-digit octal string for jk
            if instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1]=='0':
                instr_code[i].code = '12' + '0' + instr_code[i].instruction.result[0][1] + "%02o" % int(hex_jkm[0:2],16)
            else:
                instr_code[i].code = '12' + instr_code[i].instruction.operand[len(instr_code[i].instruction.operand)-1][1] + instr_code[i].instruction.result[0][1] + "%02o" % int(hex_jkm[0:2],16)
            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[i+1].code = "%06o" % int(hex_jkm[2:],16)

        #13h exp,Ah     Si      Store Si to (Ah)+jkm
        elif (len(instr_code[i].instruction.operand)==1 and is_s_type(instr_code[i].instruction.operand[0])) and \
             (len(instr_code[i].instruction.result)>2 and is_expression(instr_code[i].instruction.result[:len(instr_code[i].instruction.result)-2]) and \
              instr_code[i].instruction.result[len(instr_code[i].instruction.result)-2]==',' and \
              (is_a_type(instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1]) or instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1]=='0')):
            #I need to create the jkm value: jk = 6 bits, m = 16 bits
            #first convert the expression into a 24-bit, 6-digit hex string
            hex_jkm = "%06x" % expr_eval(instr_code[i].instruction.result[:len(instr_code[i].instruction.result)-2])
            #then break off the top two digits and convert them to a 2-digit octal string for jk
            if instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1]=='0':
                instr_code[i].code = '13' + '0' + instr_code[i].instruction.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            else:
                instr_code[i].code = '13' + instr_code[i].instruction.result[len(instr_code[i].instruction.result)-1][1] \
                                 + instr_code[i].instruction.operand[0][1] + "%02o" % int(hex_jkm[0:2],16)
            #then convert the lower 4 digits to a 6-digit octal string for m
            instr_code[i+1].code = "%06o" % int(hex_jkm[2:],16)



#Now that the instructions are fully decoded, let's go back and figure out our entry-point address
program_entry.append(locations[program_entry[0]])



if runmode=='debug':
    print "Defined locations:"
    print locations

if runmode=='normal':
    print "filename:" + output_file
    outfile = open(output_file,"w")
    outfile.write("PROGRAM NAME  :" + program_name + "\n")
    outfile.write("PROGRAM ENTRY :" + program_entry[0] + "\n")
    outfile.write("ENTRY VALUE   :" + str(program_entry[1]) + "\n")
    outfile.write("PROGRAM LENGTH:" + str(len(instr_code)) + "\n")
    outfile.write("PROGRAM ORIGIN:" + str(program_origin) + "\n")
    for i in range(0,len(instr_code)):
        outfile.write(instr_code[i].code + "\n")
    
    print "File written successfully"
        #print "%04o" % (program_origin+i) + ": " + instr_code[i].code
        #if(instr.instruction==""):
        #    print instr.code
        #elif (instr.instruction.comments!=""):
        #    print instr.code + "  " + instr.instruction.comments
        #else:
        #    print instr.code

elif runmode=='dv':
    dv_test_total = 0
    dv_test_passed = 0
    for i in range(0,len(instr_code)):
        if(instr_code[i].instruction=="" and instr_code[i].data == 0):
            print instr_code[i].code + "  " + parsed_comments[1]
            
        elif (instr_code[i].instruction != "" and instr_code[i].instruction.comments!="" and instr_code[i].data==0):
            dv_test_total = dv_test_total + 1
            parsed_comments = instr_code[i].instruction.comments.split()
            while "" in parsed_comments:
                parsed_comments.remove("")
            if len(parsed_comments)==1:
                if instr_code[i].code == instr_code[i].instruction.comments.strip():
                    print instr_code[i].code + "  " + parsed_comments[0] + "      PASS"
                    dv_test_passed = dv_test_passed + 1
                else:
                    print instr_code[i].code + "  " + parsed_comments[0] + "      FAIL"
            else:
                if instr_code[i].code == parsed_comments[0] and instr_code[i+1].code == parsed_comments[1]:
                    print instr_code[i].code + "  " + parsed_comments[0] + "      PASS"
                    dv_test_passed = dv_test_passed + 1
                else:
                    print instr_code[i].code + "  " + parsed_comments[0] + "      FAIL"

        else:
            print instr_code[i].code
    print "-------------------------"
    print "Program Name:   " + program_name
    print "Program Origin: " + str(program_origin)
    print "Program Entry:  " + program_entry[0] + " (" + str(program_entry[1]) + ")"
    print "-------------------------"
    print "PASSED: " + str(dv_test_passed) + "       " + "FAILED: " + str(dv_test_total - dv_test_passed)
    print "UNDECODED: " + str(undecoded_instructions)

elif runmode=='debug':
    print "symbols:" 
    print symbols
    for instr in instr_code:
        print "code:" + instr.code
        if instr.instruction != "":
            print "comments:" + instr.instruction.comments
            print "operands:" 
            print instr.instruction.operand
            print "result:"
            print instr.instruction.result
        






